﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace treeGridSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }
    public class ViewModel : ObservableCollection<Parent>
    {
        public ViewModel()
        {
            CreateData();
        }

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam" };

        private void CreateData()
        {
            Random r = new Random();

            for (int j = 0; j <= 1; j++)
            {
                Parent dt = new Parent()
                {
                    ID = j,
                    Name = names[j],
                    Value1 = r.Next(1, 50),
                    Value2 = r.Next(1, 100),
                    Children = new ObservableCollection<Child>()

                };


                for (int y = 1; y <= 6; y++)
                {
                    Child children = new Child()
                    {
                        ID = y + 1,
                        Name = names[j],
                        Value2 = y - 8,
                    };
                    dt.Children.Add(children);
                }

                this.Add(dt);

            }
        }
    }

    public class Parent : ICollection
    {
        public ObservableCollection<Child> Children { get; set; }
        public int ID
        {
            get { return m_ID; }
            set { m_ID = value; }
        }

        private int m_ID;
        public string Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }

        private string m_Name;
        public double Value1
        {
            get { return m_Value1; }
            set { m_Value1 = value; }
        }

        private double m_Value1;
        public double Value2
        {
            get { return m_Value2; }
            set { m_Value2 = value; }
        }
        private double m_Value2;


        public int Count
        {
            get
            {
                return Children.Count;
            }
        }

        public object SyncRoot
        {
            get
            {
                return ((ICollection)Children).SyncRoot;
            }
        }

        public bool IsSynchronized
        {
            get
            {
                return ((ICollection)Children).IsSynchronized;
            }
        }


        public IEnumerator GetEnumerator()
        {
            return this.Children.GetEnumerator();
        }

        public void CopyTo(Array array, int index)
        {
            ((ICollection)Children).CopyTo(array, index);
        }
    }

    public class Child
    {
        public double ID { get; set; }
        public string Name { get; set; }
        public double Value2 { get; set; }
    }
}

